# Introduction

[Jupyter](https://jupyter-notebook.readthedocs.io) consists of two processes: the kernel, which runs the code, and the frontend, which provides the browser-based user interface. In our lecture on [Loading, testing, and wrangling experimental data](https://github.com/mkcor/exp-testing), we run a Jupyter notebook (`demo.ipynb`)

* either with an IPython kernel installed locally (if you used the [local setup](https://github.com/mkcor/exp-testing#local-setup)),
* or with an IPython kernel contained in a Docker image hosted in the cloud (if you clicked the [binder](https://mybinder.org/) badge).

You may want to share a given computing environment, so that multiple users (your classmates, your labmates) can work with you on Jupyter notebooks. Also, you may want to work from home, accessing the notebooks which run on your workstation directly from your web browser! If so, then [JupyterHub](https://github.com/jupyterhub/jupyterhub) is what you want.

# Multi-user Hub

[JupyterHub](https://github.com/jupyterhub/jupyterhub) lets you serve notebooks to a class of students or a research group. An admin can add and remove users, who authenticate with a login/password pair.

Follow the lead of these [academic institutions](https://jupyterhub.readthedocs.io/en/latest/gallery-jhub-deployments.html#academic-institutions-research-labs-and-supercomputer-centers) who have deployed their own instances of JupyterHub!

# Multi-user Hub in a running container

[BinderHub](https://github.com/jupyterhub/binderhub) lets you serve notebooks on demand. It brings together JupyterHub and Repo2Docker, a solution for building and registering a Docker image from a Git repository.

[MyBinder](https://mybinder.org/) is a public instance of BinderHub. Academic institutions may want their instance of BinderHub to run on their own hardware (on premise).

# Interactive HPC

We mean 'interactive' as opposed to batch processing. Usually, HPC clusters use a batch-queuing system to run jobs.

[ipyparallel](https://github.com/ipython/ipyparallel) offers interactive parallel computing with IPython. The JupyterHub admin can install it for all users.

Michael Milligan describes the implementation of an interactive HPC environment at the Minnesota Supercomputing Institute (University of Minnesota), using JupyterHub, in this [paper](https://dl.acm.org/citation.cfm?id=3104159) and in this [video](https://www.youtube.com/watch?v=bNq8_nSiQXc).